﻿#pragma once

class FApplication
{
public:
    template<class T> static        T* Get()   { return reinterpret_cast<T*>(App); }
    template<class T> static const  T* Get()   { return Get<T>(App); }
    
public:
    virtual ~FApplication() = default;
    virtual bool Init();
    virtual void Update() = 0;
    virtual void Destroy();

protected:
    virtual void ParseCommandLine() = 0;
    
private:
    static FApplication* App;
};
